#!/usr/bin/python


import random

l = []
N = 20

for i in range(N):
    l.append(random.randint(1, 100))

print l


def pivot(l, start, end):
    b = start
    c = end - 1

    while b < c:
        if l[c] > l[start]:
            c -= 1
        elif l[b] <= l[start]:
            b += 1
        else:
            l[b], l[c] = l[c], l[b]

    l[start], l[b - 1] = l[b - 1], l[start]

    return b - 1


def quicksort(l, start, end):
    if start >= end:
        return

    middle = pivot(l, start, end)

    quicksort(l, start, middle)
    quicksort(l, middle + 1, end)


quicksort(l, 0, N)

print l
